
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Closing_balancesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const closing_balances = await db.closing_balances.create(
            {
                id: data.id || undefined,
        
        report_name: data.report_name
        ||
        null
            ,
            
        period_start: data.period_start
        ||
        null
            ,
            
        period_end: data.period_end
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        

        return closing_balances;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const closing_balancesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                report_name: item.report_name
            ||
            null
            ,
            
                period_start: item.period_start
            ||
            null
            ,
            
                period_end: item.period_end
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const closing_balances = await db.closing_balances.bulkCreate(closing_balancesData, { transaction });

        // For each item created, replace relation files
        

        return closing_balances;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const closing_balances = await db.closing_balances.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.report_name !== undefined) updatePayload.report_name = data.report_name;
        
        
        if (data.period_start !== undefined) updatePayload.period_start = data.period_start;
        
        
        if (data.period_end !== undefined) updatePayload.period_end = data.period_end;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await closing_balances.update(updatePayload, {transaction});

        
        

        
        

        

        return closing_balances;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const closing_balances = await db.closing_balances.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of closing_balances) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of closing_balances) {
                await record.destroy({transaction});
            }
        });


        return closing_balances;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const closing_balances = await db.closing_balances.findByPk(id, options);

        await closing_balances.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await closing_balances.destroy({
            transaction
        });

        return closing_balances;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const closing_balances = await db.closing_balances.findOne(
            { where },
            { transaction },
        );

        if (!closing_balances) {
            return closing_balances;
        }

        const output = closing_balances.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.report_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'closing_balances',
                        'report_name',
                        filter.report_name,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'closing_balances',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.period_startRange) {
                const [start, end] = filter.period_startRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    period_start: {
                    ...where.period_start,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    period_start: {
                    ...where.period_start,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.period_endRange) {
                const [start, end] = filter.period_endRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    period_end: {
                    ...where.period_end,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    period_end: {
                    ...where.period_end,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.closing_balances.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'closing_balances',
                        'report_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.closing_balances.findAll({
            attributes: [ 'id', 'report_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['report_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.report_name,
        }));
    }

    
};

